import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
import PropTypes from 'prop-types';
import OperationContainer from './operation-container';
var ConnectedOperationContainer = connect(function (state, _ref) {
  var operation = _ref.operation,
      requestSelector = _ref.requestSelector,
      operationType = _ref.operationType,
      operationCreator = _ref.operationCreator;
  return {
    operation: operation || requestSelector(state).operations[operationType || operationCreator.toString()]
  };
}, function (dispatch, ownProps) {
  return {
    sendOperation: ownProps.operationCreator ? bindActionCreators(ownProps.operationCreator, dispatch) : null
  };
}, function (stateProps, dispatchProps, _ref2) {
  var requestSelector = _ref2.requestSelector,
      operationType = _ref2.operationType,
      operationCreator = _ref2.operationCreator,
      ownProps = _objectWithoutPropertiesLoose(_ref2, ["requestSelector", "operationType", "operationCreator"]);

  return _extends({}, ownProps, stateProps, dispatchProps);
})(OperationContainer);
ConnectedOperationContainer.propTypes
/* remove-proptypes */
= process.env.NODE_ENV !== "production" ? _extends({}, OperationContainer.propTypes, {
  operation: PropTypes.oneOfType([PropTypes.shape({
    error: PropTypes.any,
    pending: PropTypes.number.isRequired
  }), PropTypes.objectOf(PropTypes.shape({
    error: PropTypes.any,
    pending: PropTypes.number.isRequired
  }))]),
  requestSelector: PropTypes.func,
  operationType: PropTypes.string,
  operationCreator: PropTypes.func
}) : {};
export default ConnectedOperationContainer;