import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import { reactComponentPropType } from './propTypesValidators';

var OperationContainer = function OperationContainer(_ref) {
  var operation = _ref.operation,
      requestKey = _ref.requestKey,
      children = _ref.children,
      Component = _ref.component,
      extraProps = _objectWithoutPropertiesLoose(_ref, ["operation", "requestKey", "children", "component"]);

  var operationObject = requestKey ? operation[requestKey] : operation;
  var loading = operationObject ? operationObject.pending > 0 : false;
  var error = operationObject ? operationObject.error : null;

  if (children) {
    return children(_extends({
      loading: loading,
      error: error
    }, extraProps));
  }

  return React.createElement(Component, _extends({
    loading: loading,
    error: error
  }, extraProps));
};

OperationContainer.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.func,
  component: reactComponentPropType('OperationContainer'),
  operation: PropTypes.oneOfType([PropTypes.shape({
    error: PropTypes.any,
    pending: PropTypes.number.isRequired
  }), PropTypes.objectOf(PropTypes.shape({
    error: PropTypes.any,
    pending: PropTypes.number.isRequired
  }))]).isRequired,
  requestKey: PropTypes.string
} : {};
export default OperationContainer;