"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _propTypesValidators = require("./propTypesValidators");

var OperationContainer = function OperationContainer(_ref) {
  var operation = _ref.operation,
      requestKey = _ref.requestKey,
      children = _ref.children,
      Component = _ref.component,
      extraProps = (0, _objectWithoutPropertiesLoose2.default)(_ref, ["operation", "requestKey", "children", "component"]);
  var operationObject = requestKey ? operation[requestKey] : operation;
  var loading = operationObject ? operationObject.pending > 0 : false;
  var error = operationObject ? operationObject.error : null;

  if (children) {
    return children((0, _extends2.default)({
      loading: loading,
      error: error
    }, extraProps));
  }

  return _react.default.createElement(Component, (0, _extends2.default)({
    loading: loading,
    error: error
  }, extraProps));
};

OperationContainer.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.func,
  component: (0, _propTypesValidators.reactComponentPropType)('OperationContainer'),
  operation: _propTypes.default.oneOfType([_propTypes.default.shape({
    error: _propTypes.default.any,
    pending: _propTypes.default.number.isRequired
  }), _propTypes.default.objectOf(_propTypes.default.shape({
    error: _propTypes.default.any,
    pending: _propTypes.default.number.isRequired
  }))]).isRequired,
  requestKey: _propTypes.default.string
} : {};
var _default = OperationContainer;
exports.default = _default;