"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _propTypesValidators = require("./propTypesValidators");

var RequestContainer = function RequestContainer(_ref) {
  var request = _ref.request,
      children = _ref.children,
      Component = _ref.component,
      isDataEmpty = _ref.isDataEmpty,
      showLoaderDuringRefetch = _ref.showLoaderDuringRefetch,
      noDataMessage = _ref.noDataMessage,
      ErrorComponent = _ref.errorComponent,
      errorComponentProps = _ref.errorComponentProps,
      LoadingComponent = _ref.loadingComponent,
      loadingComponentProps = _ref.loadingComponentProps,
      extraProps = (0, _objectWithoutPropertiesLoose2.default)(_ref, ["request", "children", "component", "isDataEmpty", "showLoaderDuringRefetch", "noDataMessage", "errorComponent", "errorComponentProps", "loadingComponent", "loadingComponentProps"]);
  var dataEmpty = isDataEmpty(request);

  if (request.pending > 0 && (showLoaderDuringRefetch || dataEmpty)) {
    return LoadingComponent ? _react.default.createElement(LoadingComponent, loadingComponentProps) : null;
  }

  if (request.error) {
    return ErrorComponent ? _react.default.createElement(ErrorComponent, (0, _extends2.default)({
      error: request.error
    }, errorComponentProps)) : null;
  }

  if (dataEmpty) {
    return noDataMessage;
  }

  if (children) {
    return typeof children === 'function' ? children(request) : children;
  }

  return _react.default.createElement(Component, (0, _extends2.default)({
    request: request
  }, extraProps));
};

RequestContainer.defaultProps = {
  isDataEmpty: function isDataEmpty(request) {
    return Array.isArray(request.data) ? request.data.length === 0 : !request.data;
  },
  showLoaderDuringRefetch: true,
  noDataMessage: null
};
RequestContainer.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.node]),
  component: (0, _propTypesValidators.reactComponentPropType)('RequestContainer'),
  request: _propTypes.default.shape({
    data: _propTypes.default.any,
    error: _propTypes.default.any,
    pending: _propTypes.default.number.isRequired
  }).isRequired,
  isDataEmpty: _propTypes.default.func,
  showLoaderDuringRefetch: _propTypes.default.bool,
  noDataMessage: _propTypes.default.node,
  errorComponent: (0, _propTypesValidators.reactComponentPropType)('RequestContainer'),
  errorComponentProps: _propTypes.default.objectOf(_propTypes.default.any),
  loadingComponent: (0, _propTypesValidators.reactComponentPropType)('RequestContainer'),
  loadingComponentProps: _propTypes.default.objectOf(_propTypes.default.any)
} : {};
var _default = RequestContainer;
exports.default = _default;